<?php

namespace backend\modules\reports\controllers;

use backend\modules\master\models\Product;
use backend\modules\reports\models\CompilationStockReport;
use backend\modules\reports\models\DeliveredPurchaseReport;
use backend\modules\reports\models\PurchaseReportByProduct;
use backend\modules\reports\models\ReceivedOrder;
use backend\modules\reports\models\SaleReportByProduct;
use backend\modules\reports\models\SaleReportByProductSearch;
use backend\modules\reports\models\AllStockInventory;
use COM;
use Mpdf\Mpdf;
use yii\data\ActiveDataProvider;
use yii\data\ArrayDataProvider;
use Yii;
use yii\db\Query;
use yii\helpers\ArrayHelper;


class CompilationStockReportController extends \yii\web\Controller
{
    public function actionIndex($excel = null)
    {
        $model = new CompilationStockReport();
        // print_r($model);die();
        $current_month = date("m");
        if ($current_month >= 4) {
            $from_year = date("Y");
            $from_date = $from_year . '-04-01';
        } else {
            $from_year = date("Y") - 1;
            $from_date = $from_year . '-04-01';
        }
        $from_date = date("Y-m-d");
        $to_date = date("Y-m-d");

        $query = Yii::$app->db->createCommand("CALL compilation_stock_report(:params_1,:params_2)")
            ->bindValue(':params_1', $from_date)
            ->bindValue(':params_2', $to_date)
            ->queryAll();
        if ($model->load(Yii::$app->request->get())) {
            $data = Yii::$app->request->get('CompilationStockReport');
            //  print_r($data);
           // print_r($data['vendor_name']);die();
            //  print_r("nnnnn");
            if ($model->from_date != null && $model->to_date != null) {
                $from_date = $model->from_date;
                $to_date = $model->to_date;
            }

            $query = Yii::$app->db->createCommand("CALL compilation_stock_report(:params_1,:params_2)")
                ->bindValue(':params_1', $from_date)
                ->bindValue(':params_2', $to_date)->queryAll();
            $array = [];
            $a = 0;
            if ($data['product_name'] != null && $data['vendor_name'] == null && $data['product_category'] == null) {
                $a = 1;
                foreach ($query as $val) {
                    if ($val['product_id'] == $data['product_name']) {
                        array_push($array, $val);
                    }
                }
            } else if ($data['product_name'] == null && $data['vendor_name'] != null && $data['product_category'] == null) {
                $a = 1;
                foreach ($query as $val) {
                    if ($val['vendor_id'] == $data['vendor_name']) {
                        array_push($array, $val);
                    }
                }
            } else if ($data['product_name'] == null && $data['vendor_name'] == null && $data['product_category'] != null) {
                $a = 1;
                foreach ($query as $val) {
                    if ($val['product_category'] == $data['product_category']) {
                        array_push($array, $val);
                    }
                }
            } else if ($data['product_name'] != null && $data['vendor_name'] != null && $data['product_category'] == null) {
                $a = 1;
                foreach ($query as $val) {
                    if ($val['product_id'] == $data['product_name'] && $val['vendor_name'] == $data['vendor_name']) {
                        array_push($array, $val);
                    }
                }
            } else if ($data['product_name'] != null && $data['vendor_name'] == null && $data['product_category'] != null) {
                $a = 1;
                foreach ($query as $val) {
                    if ($val['product_id'] == $data['product_name'] && $val['product_category'] == $data['product_category']) {
                        array_push($array, $val);
                    }
                }
            } else if ($data['product_name'] == null && $data['vendor_name'] != null && $data['product_category'] != null) {
                $a = 1;
                foreach ($query as $val) {
                    if ($val['vendor_name'] == $data['vendor_name'] && $val['product_category'] == $data['product_category']) {
                        array_push($array, $val);
                    }
                }
            }
            if ($a == 0) {
                $array = $query;
            } else {
                if ($array == null) {
                    $array = [];
                }
            }
            //  print_r($array);die();
            $dataProvider = new ArrayDataProvider([
                'allModels' => $array,
                // 'pagination' => false,
            ]);
            if ($excel == true) {
                $this->actionExcelreport($dataProvider, $to_date);
            }
            return $this->render('index', [
                'dataProvider' => $dataProvider,
                'model' => $model,
            ]);
        }

        //  print_r($array);die();
        $dataProvider = new ArrayDataProvider([
            'allModels' => $query,
            // 'pagination' => false,
        ]);

        if ($excel == true) {
            $this->actionExcelreport($dataProvider, $to_date);
        }

        return $this->render('index', [
            'dataProvider' => $dataProvider,
            'model' => $model,
        ]);
    }
    // public function actionMonthlySummary($prod_id)
    // {
    //     $model= new CompilationStockReport();
    //     $current_month = date("m");
    //     if ($current_month > 4) {
    //         $from_year = date("Y");
    //         $from_date = $from_year . '-04-01';
    //     } else {
    //         $from_year = date("Y") - 1;
    //         $from_date = $from_year . '-04-01';
    //     }
    //     $to_date = date("Y-m-d");
    //     $query = Yii::$app->db->createCommand("CALL monthly_compilation_report(:params_1,:params_2,:params_3)")
    //         ->bindValue(':params_1', $prod_id)
    //         ->bindValue(':params_2', $from_date)
    //         ->bindValue(':params_3', $to_date)
    //         ->queryAll();
    //     $dataProvider = new ArrayDataProvider([
    //         'allModels' => $query,
    //     ]);

    //     if ($model->load(Yii::$app->request->get())) {
    //         $data = Yii::$app->request->get('CompilationStockReport');
    //         //  print_r($data);
    //         //  print_r("nnnnn");
    //         if ($model->from_date != null && $model->to_date != null) {
    //             $from_date = $model->from_date;
    //             $to_date = $model->to_date;
    //         }

    //         $query = Yii::$app->db->createCommand("CALL monthly_compilation_report(:params_1,:params_2,:params_3)")
    //         ->bindValue(':params_1', $prod_id)
    //         ->bindValue(':params_2', $from_date)
    //         ->bindValue(':params_3', $to_date)
    //         ->queryAll();

    //         $dataProvider = new ArrayDataProvider([
    //             'allModels' => $query,
    //         ]);
    //     }

    //     $product = Product::find()->where(['id' => $prod_id])->one();
    //     return $this->render('monthly-summary', [
    //         'dataProvider' => $dataProvider,
    //         'from_date' => $from_date,
    //         'to_date' => $to_date,
    //         'product_name' => $product->product_name,
    //         'model'=>$model
    //     ]);
    // }

    public function actionMonthlySummary($prod_id, $print = null)
    {
        $model = new CompilationStockReport(); 

        $query_1 = AllStockInventory::find()->where(['product_id' => $prod_id])->andWhere(['tan_type' => 'Received']);
        if (Yii::$app->request->get()) {
            $model->load(Yii::$app->request->queryParams);
            $query_1->andFilterWhere(['between', 'date', $model->from_date, $model->to_date]);
        }
        $query_1->orderBy(['date' => SORT_DESC,'tan_id'=> SORT_DESC]);
        $dataProvider_1 = new ActiveDataProvider([
            'query' => $query_1
        ]);
        $query_2 = AllStockInventory::find()->where(['product_id' => $prod_id])->andWhere(['tan_type' => 'Delivered']);
        if (Yii::$app->request->get()) {
            $query_2->andFilterWhere(['between', 'date', $model->from_date, $model->to_date]);
        }
        $query_2->orderBy(['date' => SORT_DESC,'tan_id'=> SORT_DESC]);
        $dataProvider_2 = new ActiveDataProvider([
            'query' => $query_2
        ]);
        $purchase = $query_1->sum('received_product_quantity');
        $sale = $query_2->sum('delivered_product_quantity');
       
       
        //  print_r(1);die();
        $product = Product::find()->where(['id' => $prod_id])->one();
        //  print_r($product->id);die();
        if ($print != null) {
            $dataProvider_1->pagination = false;
            $dataProvider_2->pagination = false;
            $mpdf = new mPDF;
            $mpdf->showImageErrors = true;
            $mpdf->WriteHTML($this->renderPartial('/compilation-stock-report/exportpdf', [
                'dataProvider_1' => $dataProvider_1,
                'dataProvider_2' => $dataProvider_2,
                'model' => $model,
                'product' => $product->product_name,
                'product_id' => $product->id

            ]));
            $mpdf->Output('compilation-stock-report.pdf', 'I');
        }

        return $this->render('monthly-summary', [
            'dataProvider_1' => $dataProvider_1,
            'dataProvider_2' => $dataProvider_2,
            'model' => $model,
            'product' => $product->product_name,
            'product_id' => $product->id,
            'purchase' => $purchase,
            'sale' => $sale

        ]);
    }
    public function actionExcelreport($dataProvider = null, $excel = null)
    {

        $dataProvider->pagination = false;
        $phpExcel = new \PHPExcel;

        $phpExcel->getProperties()->setDescription("Excel SpreadSheet in PHP");
        $writer = \PHPExcel_IOFactory::createWriter($phpExcel, "Excel2007");
        $sheet = $phpExcel->getActiveSheet();

        $sheet->getRowDimension('A1')->setRowHeight(35);
        $sheet->getCell('A1')->setValue('Mohapatra Scientific Supply');
        $sheet->getCell('A3')->setValue('MOHASYN');
        $sheet->getCell('A4')->setValue('Bhubaneshwar');
        $sheet->getCell('A5')->setValue('Stock Summary');
        $sheet->getCell('A7')->setValue('Basis for valuation: Simple Average Cost method');
        // Making headers text bold and larger
        $sheet->getStyle('A1:J1')->getFont()->setBold(true)->setSize(12);
        $sheet->getStyle('A7:J7')->getFont()->setBold(true)->setSize(12);
        $sheet->getStyle('A7')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
        $sheet->getStyle('A1')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
        $sheet->getStyle('A2')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
        $sheet->getStyle('A3')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
        $sheet->getStyle('A4')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
        $sheet->getStyle('A5')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
        $sheet->getStyle('A6')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);

        $sheet->getColumnDimension('A')->setWidth(30);
        $sheet->getColumnDimension('B')->setWidth(20);
        $sheet->getColumnDimension('C')->setWidth(15);
        $sheet->getColumnDimension('D')->setWidth(15);
        $sheet->getColumnDimension('E')->setWidth(15);
        $sheet->getColumnDimension('F')->setWidth(15);

        $sheet->mergeCells('A1:J1');
        $sheet->mergeCells('A2:J2');
        $sheet->mergeCells('A3:J3');
        $sheet->mergeCells('A4:J4');
        $sheet->mergeCells('A5:J5');
        $sheet->mergeCells('A6:J6');
        $sheet->mergeCells('A7:J7');

        $sheet->mergeCells('A8:D8');
        $sheet->mergeCells('H8:J8');
        $sheet->setCellValue('A8',  'Item Details');
        $sheet->setCellValue('E8',  'Opening Balance');
        $sheet->setCellValue('F8',  'Inward');
        $sheet->setCellValue('G8',  'Outward');
        $sheet->setCellValue('H8',  'Closing Balance');

        $sheet->getStyle('A8')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
        $sheet->getStyle('E8')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
        $sheet->getStyle('F8')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
        $sheet->getStyle('G8')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
        $sheet->getStyle('H8')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
        $sheet->getStyle('A8')->getFont()->setBold(true)->setSize(12);
        $sheet->getStyle('E8')->getFont()->setBold(true)->setSize(12);
        $sheet->getStyle('F8')->getFont()->setBold(true)->setSize(12);
        $sheet->getStyle('G8')->getFont()->setBold(true)->setSize(12);
        $sheet->getStyle('H8')->getFont()->setBold(true)->setSize(12);

        $sheet->setCellValue('A9',  'Category');
        $sheet->setCellValue('B9',  'Name');
        $sheet->setCellValue('C9',  'Selling Price');
        $sheet->setCellValue('D9',  'Buying Price');
        $sheet->setCellValue('E9',  'Quantity');
        $sheet->setCellValue('F9',  'Quantity');
        $sheet->setCellValue('G9',  'Quantity');
        $sheet->setCellValue('H9',  'Quantity');
        $sheet->setCellValue('I9',  'Average price');
        $sheet->setCellValue('J9',  'Amount');

        $sheet->getStyle('A9')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
        $sheet->getStyle('B9')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
        $sheet->getStyle('C9')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
        $sheet->getStyle('D9')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
        $sheet->getStyle('E9')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
        $sheet->getStyle('F9')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
        $sheet->getStyle('G9')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
        $sheet->getStyle('H9')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
        $sheet->getStyle('I9')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
        $sheet->getStyle('J9')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);


        $row = 10;
        $amount = 0;
        $op = 0;
        $closing = 0;
        $inward = 0;
        $outward = 0;
        foreach ($dataProvider->models as $data) {


            $amount = $amount + $data['amount'];
            $op = $op + $data['opening_balance'];
            $inward = $inward + $data['inward'];
            $outward = $outward + $data['outward'];
            $closing = $closing + $data['closing'];
            $product = Product::find()->where(['id' => $data['product_id']])->one();
            // $closing=$closing+$closingbalance;
            // $sheet->getStyle('C' . $row)->getAlignment()->setWrapText(true);
            // $sheet->getStyle('D' . $row)->getAlignment()->setWrapText(true);
            $sheet->setCellValue('A' . $row,  $data['product_category']);
            $sheet->setCellValue('B' . $row,  $product->product_name);
            $sheet->setCellValue('C' . $row,  $data['selling_price']);
            $sheet->setCellValue('D' . $row,  $data['buying_price']);
            $sheet->setCellValue('E' . $row,  $data['opening_balance']);
            $sheet->setCellValue('F' . $row,  $data['inward']);
            $sheet->setCellValue('G' . $row,  $data['outward']);
            $sheet->setCellValue('H' . $row,  $data['closing']);
            $sheet->setCellValue('I' . $row,  $data['avg_price']);
            $sheet->setCellValue('J' . $row,  $data['amount']);
            $row++;
        }

        $sheet->setCellValue('A' . $row, 'Grand Total');
        $sheet->setCellValue('B' . $row,  '');
        $sheet->setCellValue('E' . $row, (string)$op);
        $sheet->setCellValue('F' . $row,  (string)$inward);
        $sheet->setCellValue('G' . $row,  (string)$outward);
        $sheet->setCellValue('H' . $row,  (string)$closing);
        $sheet->setCellValue('J' . $row,  (string)$amount);


        ob_clean();
        ob_start();

        header('Content-type: application/vnd.ms-excel'); // It will be called file.xls  
        header('Content-Disposition: attachment; filename="Compilation_stock_summary.xls"'); // Write file to the browser 

        $writer->save('php://output');
        ob_flush();
        exit();
    }
}
