<?php

namespace backend\modules\reports\controllers;

use Yii;
use backend\modules\reports\models\SaleOrderReport;
use backend\modules\reports\models\SaleOrderReportSearch;
use backend\modules\reports\models\SaleReportByProduct;
use backend\modules\master\models\Customer;
use backend\modules\users\models\SaleOrderProduct;
use backend\modules\users\models\SaleOrder;
use backend\modules\master\models\Product;
use yii\helpers\ArrayHelper;
use yii\helpers\Json;
use yii\data\ActiveDataProvider;
use common\models\User;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii2tech\spreadsheet\Spreadsheet;
use yii\filters\VerbFilter;
use Mpdf\Mpdf;


class SaleOrderReportController extends \yii\web\Controller
{
    public function actionIndex($print=null,$detailedprint=null,$viewprint=null,$excel=null)
    {
    	$model = new SaleOrderReport();
    	  $searchModel = new SaleOrderReportSearch();
    	$dataProvider = $searchModel->search(Yii::$app->request->queryParams);
        $query=SaleOrderReport::find();

    	if($model->load(Yii::$app->request->get())){

    		$query->andFilterWhere(['like','customer_type',$model->type_of_customer])
                   ->andFilterWhere(['like', 'Particulars', $model->customer_name])
                   ->andFilterWhere(['in', 'created_by', $model->created_by_user])
                   ->andFilterWhere(['like', 'executive', $model->executive_name]);

             if($model->converted){
                $find=SaleOrderReport::find()->select('converted_to')->where(['converted_to'=>$model->converted])->column();
               $query->andFilterWhere(['in', 'converted_to', $find]);}  
                   
            if($model->sel_date){
                if($model->sel_date=='Today'){
                    
                $query->andFilterWhere(['like', 'Date', date('Y-m-d')]);
                }elseif($model->sel_date=='Current Week') {
                    $query->andFilterWhere(['>=', 'Date',date('Y-m-d',strtotime('last monday')) ]);
                }elseif($model->sel_date=='Current Month') {
                    $query->andFilterWhere(['>=', 'Date',date ('Y-m-d', strtotime ('first day of this month')) ]);
                }
                elseif($model->sel_date=='Current Year') {
                    $query->andFilterWhere(['>=', 'Date',date('Y-m-d',strtotime(date('Y-01-01')))]);
                }elseif($model->sel_date=='Custom'){

                    $query->andFilterWhere(['between', 'Date', $model->from_date,$model->to_date]);
                } 
            } 
            if($model->Sales_orderBy){

                if($model->Sales_orderBy=='Voucher # Asc'){
                 $query->orderBy(['CAST(vch_no as unsigned)' => SORT_ASC]);
                } elseif($model->Sales_orderBy=='Voucher # Dsc'){
                    $query->orderBy(['CAST(vch_no as unsigned)' => SORT_DESC]);
                }elseif($model->Sales_orderBy=='Date Asc'){
                    $query->orderBy(['Date' => SORT_ASC]);
                }elseif($model->Sales_orderBy=='Date Dsc'){
                    $query->orderBy(['Date' => SORT_DESC]);
                }
            }      
    	}
        $dataProvider = new ActiveDataProvider([
            'query' => $query,
            
        ]);
        //FOR DETAILED PDF
        if($print!=null)
        {
          if($model->from_date!='' && $model->to_date!='')
          {
            $dataProvider = new ActiveDataProvider([
            'query' => SaleReportByProduct::find()->where(['between','Date',$model->from_date,$model->to_date ]),
              ]);
          }
          else
          {
              $dataProvider = new ActiveDataProvider([
            'query' => SaleReportByProduct::find(),
              ]);
          }
          $for = "detailpdf";
          $this->actionExportpdf($dataProvider,$model,$for);
        }
        //FOR FOR DETAILED PRINT
        if($detailedprint!=null)
        {
          if($model->from_date!='' && $model->to_date!='')
          {
            $dataProvider = new ActiveDataProvider([
            'query' => SaleReportByProduct::find()->where(['between','Date',$model->from_date,$model->to_date ]),
              ]);
          }
          else
          {
              $dataProvider = new ActiveDataProvider([
            'query' => SaleReportByProduct::find(),
              ]);
          }
          $for = 'detailprint';
          $this->actionExportpdf($dataProvider,$model,$for);
        }
        //FOR PRINT
        if($viewprint!=null)
        {
           if($model->from_date!='' && $model->to_date!='')
              {
                  $dataProvider = new ActiveDataProvider([
                    'query' => SaleOrderReport::find()->where(['between','Date',$model->from_date,$model->to_date]),
                ]);
              }
              else{
                $dataProvider = new ActiveDataProvider([
                    'query' => SaleOrderReport::find()
                ]);
              }
            $for = 'viewprint';
            $this->actionExportpdf($dataProvider,$model,$for);
        }
        //FOR EXCEL
        if($excel!=null)
        {
            $this->actionExcelSaleorderreport($model);
        }
        return $this->render('index', [
            'model' => $model,  
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }
     public function actionCustomerdetails($searchTerm=null)
    {   
        if(!$searchTerm)
        $customer=Customer::find()->limit(10)->all();
        else
        $customer=Customer::find()->where(["like","business_name",$searchTerm])->limit(10)->all();

        $customerlist=ArrayHelper::map($customer, 'business_name', 'business_name');
        return json_encode($customerlist);
    }
    public function actionExportpdf($data=null,$model=null,$for=null,$id=null)
    {
	 ini_set("pcre.backtrack_limit", "5000000");
         if($for=='detailpdf')
         {
            $data->pagination = false;
            $mpdf = new mPDF;
            $mpdf->showImageErrors = true;
            $mpdf->WriteHTML($this->renderPartial('/sale-order-report/exportpdf', [
                'dataProvider' => $data,
                'model' => $model,
            ]));
            $mpdf->Output('saleorderreport.pdf', 'D');
         } 
         else if($for == 'detailprint')
         {
              $data->pagination = false;
              $mpdf = new mPDF;
              $mpdf->showImageErrors = true;
              $mpdf->WriteHTML($this->renderPartial('/sale-order-report/exportpdf', [
                  'dataProvider' => $data,
                  'model'=>$model,
              ]));
              $mpdf->Output('saleorderreport.pdf', 'I');
         } 
         else if ($for=='viewprint') {

            $data->pagination = false;
            $mpdf = new mPDF;
            $mpdf->showImageErrors = true;
            $mpdf->WriteHTML($this->renderPartial('/sale-order-report/printpdf', [
                'dataProvider' => $data,
                'model'=>$model,

            ]));
            $mpdf->Output('saleorderreport.pdf', 'I');
          } 
          else
          {
                $model = SaleOrder::find()->where(['id'=>$id])->one();
                $products=SaleOrderProduct::find()->where(['sale_order_no'=>$id])->all();
                $count=SaleOrderProduct::find()->where(['sale_order_no'=>$id])->count();
                // print_r($count);die();
                $find = SaleOrderProduct::find()->where(['sale_order_no'=>$id])->all();
                
                $dataProvider = new ActiveDataProvider([
                    'query' => SaleOrder::find()->where(['id'=>$id])
                ]);
                $dataProvider->pagination = false;
                $mpdf = new mPDF;
                $mpdf->showImageErrors = true;
                $mpdf->WriteHTML($this->renderPartial('/sale-order-report/salereportpdf', [
                    'dataProvider' => $dataProvider,
                    'products' => $products,
                    'count' =>$count,
                    'model' => $model,           
                ]));
                $find=SaleOrder::findOne($id);
                $sale_order_id=$find->sale_order_id;
                $mpdf->Output($sale_order_id.'-SaleOrderReport.pdf', 'I');
          }
    }

    public function actionExcelSaleorderreport($mod=null)
    {  
      if($mod!=null)
      {
        if($mod->from_date!='' && $mod->to_date!='')
        {
          $dataProvider = new ActiveDataProvider([
            'query' => SaleReportByProduct::find()->where(['between','Date',$mod->from_date,$mod->to_date ]),
	    'pagination'=>false,
          ]);
        }
      else
      {
          $dataProvider = new ActiveDataProvider([
            'query' => SaleReportByProduct::find(),
	    'pagination'=>false,
          ]);
      }
      }
      
       $phpExcel = new \PHPExcel;
     
      $phpExcel ->getProperties()->setDescription("Excel SpreadSheet in PHP");
      $writer = \PHPExcel_IOFactory::createWriter($phpExcel, "Excel2007");
      $sheet = $phpExcel ->getActiveSheet();

      $sheet->getRowDimension('A1')->setRowHeight(35);
      $sheet ->getCell('A1')->setValue('Sales Order Detailed Report');
      $sheet->getStyle('A1')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
      // Making headers text bold and larger
      $sheet->getStyle('A1:K1')->getFont()->setBold(true)->setSize(12);


      if($mod!='')
      {
       if($mod->from_date!=null)
      
      {
        $sheet->setCellValue('A3', date('d-m-Y', strtotime($mod->from_date)).' to '.date('d-m-Y', strtotime($mod->to_date)));
        $sheet->getStyle('A3')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
        // $sheet->getStyle('A3:K3')->getFont()->setBold(true)->setSize(12);
      }
     }
      else{
        $sheet->setCellValue('A3', '');
        // $sheet->getStyle('A3:K3')->getFont()->setBold(true)->setSize(12);
      }


      $sheet->getColumnDimension('A')->setWidth(20);
      $sheet->getColumnDimension('B')->setWidth(9);
      $sheet->getColumnDimension('C')->setWidth(40);
      $sheet->getColumnDimension('D')->setWidth(40);
      $sheet->getColumnDimension('E')->setWidth(5);
      $sheet->getColumnDimension('F')->setWidth(10);
      $sheet->getColumnDimension('G')->setWidth(10);
      $sheet->getColumnDimension('H')->setWidth(10);
      $sheet->getColumnDimension('I')->setWidth(10);
      $sheet->getColumnDimension('J')->setWidth(10);
      $sheet->getColumnDimension('K')->setWidth(10);
      $sheet->getColumnDimension('L')->setWidth(12);

      $sheet->getStyle('A4')->getFill()->setFillType(\PHPExcel_Style_Fill::FILL_SOLID)->getStartColor()->setRGB('BBB9B8');
      $sheet->getStyle('B4')->getFill()->setFillType(\PHPExcel_Style_Fill::FILL_SOLID)->getStartColor()->setRGB('BBB9B8');
      $sheet->getStyle('C4')->getFill()->setFillType(\PHPExcel_Style_Fill::FILL_SOLID)->getStartColor()->setRGB('BBB9B8');
      $sheet->getStyle('D4')->getFill()->setFillType(\PHPExcel_Style_Fill::FILL_SOLID)->getStartColor()->setRGB('BBB9B8');
      $sheet->getStyle('E4')->getFill()->setFillType(\PHPExcel_Style_Fill::FILL_SOLID)->getStartColor()->setRGB('BBB9B8');
      $sheet->getStyle('F4')->getFill()->setFillType(\PHPExcel_Style_Fill::FILL_SOLID)->getStartColor()->setRGB('BBB9B8');
      $sheet->getStyle('G4')->getFill()->setFillType(\PHPExcel_Style_Fill::FILL_SOLID)->getStartColor()->setRGB('BBB9B8');
      $sheet->getStyle('H4')->getFill()->setFillType(\PHPExcel_Style_Fill::FILL_SOLID)->getStartColor()->setRGB('BBB9B8');
      $sheet->getStyle('I4')->getFill()->setFillType(\PHPExcel_Style_Fill::FILL_SOLID)->getStartColor()->setRGB('BBB9B8');
      $sheet->getStyle('J4')->getFill()->setFillType(\PHPExcel_Style_Fill::FILL_SOLID)->getStartColor()->setRGB('BBB9B8');
      $sheet->getStyle('K4')->getFill()->setFillType(\PHPExcel_Style_Fill::FILL_SOLID)->getStartColor()->setRGB('BBB9B8');
      $sheet->getStyle('L4')->getFill()->setFillType(\PHPExcel_Style_Fill::FILL_SOLID)->getStartColor()->setRGB('BBB9B8');

      $sheet->mergeCells('A1:K1');
      $sheet->mergeCells('A3:K3');

      $sheet->setCellValue('A4',  'Date');
      $sheet->setCellValue('B4',  'SO No.');
      $sheet->setCellValue('C4',  'Customer');
      $sheet->setCellValue('D4',  'Product');
      $sheet->setCellValue('E4',  'Qty');
      $sheet->setCellValue('F4',  'Tax');
      $sheet->setCellValue('G4',  'Price');
      $sheet->setCellValue('H4',  'TCS');
      $sheet->setCellValue('I4',  'Total');
      $sheet->setCellValue('J4',  'Delivered');
      $sheet->setCellValue('K4',  'Pending');
      $sheet->setCellValue('L4',  'Status');

        $row=5;
        foreach ($dataProvider->models as $data) {

//print_r($data->sale_order_id);die();
          $particulars = SaleOrderReport::find()->where(['sale_order_id'=>$data->sale_order_id])->one();  
          $models = SaleOrder::find()->where(['id'=>$data->sale_order_id])->one();
          $product = Product::find()->where(['id'=>$data->product_id])->one();
          $tax = 0;



            if($data->tax_included==1)
                    {
                        if($data->discount_type=="FLAT")
                        {
                             $tax =  $data->gross_amount-($data->GrossTotal-$data->ItemDiscount);
                        }
                        else if($data->discount_type=="%")
                        {
                             $tax = $data->gross_amount-($data->GrossTotal-(($data->GrossTotal*$data->ItemDiscount)/100));
                        }
                        else
                        {
                             $tax =  $data->gross_amount - $data->GrossTotal;
                        }

                    }
                    else
                    {
                         $tax=0;
                    }
          
            $tax = (string)$tax;

  
        $tcs_percentage =0;
        $product_tcs =0;
        $gtotal =0;
        if($models->is_tcs==1)
        {
          $tcs_percentage = (($models->tcs_amount/($models->total_amount-$models->tcs_amount)*100));
          $product_tcs = ($data->gross_amount*($tcs_percentage/100));

          $gtotal = $gtotal+($product_tcs+$data->gross_amount);
        }
        else
        {
          $gtotal = $gtotal + $data->gross_amount;
        }
        $product_tcs = (string)$product_tcs;
        $gtotal = (string)$gtotal;

            $price = 0;

            if($data->discount_type=="FLAT")
               $price = $data->GrossTotal-$data->ItemDiscount;
            if($data->discount_type=="%")
               $price = $data->GrossTotal-(($data->GrossTotal*$data->ItemDiscount)/100);
           if($data->discount_type=="")
               $price = $data->GrossTotal;

           $price = (string)$price;
           $paid =0;
           $pending =0;
           $status = 'Pending';
           if($models->dc_status>=1)
            {
                $paid =$data->Qty;
            }
            else
            {
                $paid =0;;
            }
            if($models->dc_status<1)
            {
                $pending = $data->Qty;
            }
            else
            {
                $pending=0;
            }
            $paid = (string)$paid;
            $pending = (string)$pending;
            if($models->dc_status==2)
            {
               $status = 'DELIVERED';
            }
            else
            {
                $status = 'PENDING';
            }




           $sheet->getStyle('C'.$row)->getAlignment()->setWrapText(true);
           $sheet->getStyle('D'.$row)->getAlignment()->setWrapText(true);
        $sheet->setCellValue('A' . $row,  date('d/m/Y', strtotime($particulars->Date)));
        $sheet->setCellValue('B' . $row,  $models->sale_order_id);
        $sheet->setCellValue('C' . $row,  $particulars->Particulars);    
        $sheet->setCellValue('D' . $row,  $product->product_name); 
        $sheet->setCellValue('E' . $row,  $data->Qty); 
        $sheet->setCellValue('F' . $row,  $tax); 
        $sheet->setCellValue('G' . $row,  $price); 
        $sheet->setCellValue('H' . $row,  $product_tcs);
        $sheet->getStyle('H' . $row)->getNumberFormat()->setFormatCode('0.00');
        $sheet->setCellValue('I' . $row,  $gtotal); 
        $sheet->getStyle('I' . $row)->getNumberFormat()->setFormatCode('0.00');
        $sheet->setCellValue('J' . $row,  $paid); 
        $sheet->setCellValue('K' . $row,  $pending); 
        $sheet->setCellValue('L' . $row,  $status); 
        $row++;   

       } 

       // $sheet->setCellValue('B' . $row, 'Total(Rs)');
       //  $sheet->setCellValue('G' . $row,  (string)$totalquantity);
       //  $sheet->setCellValue('H' . $row,  '-'); 
       //  $sheet->setCellValue('I' . $row,  '-'); 
       //  $sheet->setCellValue('J' . $row,  (string)$totalprice); 
       //  $sheet->setCellValue('K' . $row,  (string)$totaltaxamount); 
       //  $sheet->setCellValue('L' . $row,  (string)$totalothercharges); 
       //  $sheet->setCellValue('M' . $row,  (string)$totalgrossamount); 


       //  $sheet->getStyle('B'.$row)->getFont()->setBold(true)->setSize(11);
       //  $sheet->getStyle('G'.$row)->getFont()->setBold(true)->setSize(11);
       //  $sheet->getStyle('H'.$row)->getFont()->setBold(true)->setSize(11);
       //  $sheet->getStyle('I'.$row)->getFont()->setBold(true)->setSize(11);
       //  $sheet->getStyle('J'.$row)->getFont()->setBold(true)->setSize(11);
       //  $sheet->getStyle('K'.$row)->getFont()->setBold(true)->setSize(11);
       //  $sheet->getStyle('L'.$row)->getFont()->setBold(true)->setSize(11);
       //  $sheet->getStyle('M'.$row)->getFont()->setBold(true)->setSize(11);

      ob_clean();
        ob_start();
        
         header('Content-type: application/vnd.ms-excel'); // It will be called file.xls  
         header('Content-Disposition: attachment; filename="saleorderreport.xls"'); // Write file to the browser 

      $writer->save('php://output');
      ob_flush();
      exit();
    }

}
