<?php

namespace backend\modules\reports\models;

use Yii;

/**
 * This is the model class for table "all_stock_inventory".
 *
 * @property string $product_id
 * @property string|null $product_name
 * @property int|null $received_product_quantity
 * @property int|null $delivered_product_quantity
 * @property string|null $date
 * @property int $tan_id
 * @property string $tan_type
 */
class AllStockInventory extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'all_stock_inventory';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['product_name'], 'string'],
            [['received_product_quantity', 'delivered_product_quantity', 'tan_id'], 'integer'],
            [['product_id', 'date'], 'string', 'max' => 32],
            [['tan_type'], 'string', 'max' => 9],
            [['business_name'], 'safe']
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'product_id' => 'Product ID',
            'product_name' => 'Product Name',
            'received_product_quantity' => 'Received Product Quantity',
            'delivered_product_quantity' => 'Delivered Product Quantity',
            'date' => 'Date',
            'tan_id' => 'Tan ID',
            'tan_type' => 'Tan Type',
            'business_name' => 'Bussiness Name'
        ];
    }
}
