<?php

namespace backend\modules\reports\models;

use Yii;

/**
 * This is the model class for table "inward_supplies_details".
 *
 * @property int $id
 * @property int $product_id
 * @property int $bill_id
 * @property string|null $discount_type
 * @property string|null $description
 * @property int $vendor_id
 * @property string|null $vendor_bill_no
 * @property string|null $sender_gst_id
 * @property int $qty
 * @property string|null $unit
 * @property float $price
 * @property float|null $discount
 * @property string|null $tax
 * @property int|null $incl_tax
 * @property float $amount
 * @property int $is_deleted
 * @property string $bill_date
 * @property string $created_at
 * @property string $updated_at
 */
class InwardSuppliesDetails extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public $expense;
    public $hsn_code;
    public $supply_type;
    public $reverse_charges;
    public $location;
    public $assesment;
    public $duration;
    public $time_frame;
    public $from;
    public $to;


    public static function tableName()
    {
        return 'inward_supplies_details';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['id', 'product_id', 'bill_id', 'vendor_id', 'qty', 'incl_tax', 'is_deleted'], 'integer'],
            [['bill_id', 'qty', 'price', 'amount'], 'required'],
            [['description', 'vendor_bill_no', 'sender_gst_id'], 'string'],
            [['price', 'discount', 'amount'], 'number'],
            [['created_at', 'updated_at','expense','hsn_sac_code','reverse_charges','location','bill_date','product_id', 'vendor_id','bill_type','supply_type','point_of_supply','supply_attracts','product_name','vendor_name','time_frame','from','to','location','city'], 'safe'],
            [['discount_type', 'unit'], 'string', 'max' => 254],
            [['tax'], 'string', 'max' => 32],
            [['to'], 'compare' ,'compareAttribute' => 'from','operator'=>'>=', 'message'=> 'To Date must be equal/greater than From Date'],

        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'product_id' => 'Product ID',
            'bill_id' => 'Bill ID',
            'discount_type' => 'Discount Type',
            'description' => 'Description',
            'vendor_id' => 'Vendor ID',
            'vendor_bill_no' => 'Vendor Bill No',
            'sender_gst_id' => 'Sender Gst ID',
            'qty' => 'Qty',
            'unit' => 'Unit',
            'price' => 'Price',
            'discount' => 'Discount',
            'tax' => 'Tax',
            'incl_tax' => 'Incl Tax',
            'amount' => 'Amount',
            'is_deleted' => 'Is Deleted',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }
   
}
