<?php

namespace backend\modules\reports\models;


use  Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use backend\modules\reports\models\SaleReportByProduct;

/**
 * This is the model class for table "Sale_report_by_product".
 *
 * @property string|null $Date
 * @property string|null $Particulars
 * @property string|null $VCh No
 * @property string|null $GST No
 * @property string $product_name
 * @property string|null $Qty
 * @property float|null $Rate
 * @property string|null $Item Discount
 * @property float|null $Gross Total
 * @property string|null $TaxAmount
 * @property string|null $VendorDEALER
 * @property string|null $Units
 * @property string|null $Description
 * @property string $Category
 * @property string $Executive
 * @property string $customer_type
 * @property string $discount_type
 * @property string $created_by



 */
class SaleReportByProduct extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'Sale_report_by_product';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['Date','discount_type'], 'safe'],
            // [['product_name', 'Category'], 'required'],
            [['Rate', 'Gross Total','gross_amount'], 'number'],
            [['Particulars', 'Item Discount', 'TaxAmount', 'VendorDEALER', 'Units', 'Description','customer_type','created_by'], 'string', 'max' => 254],
            [['VChNo', 'GSTNo'], 'string', 'max' => 32],
            [['product_name','Executive'], 'string', 'max' => 512],
            [['Qty'], 'string', 'max' => 30],
            [['Category'], 'string', 'max' => 128],

        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'Date' => 'Date',
            'Particulars' => 'Particulars',
            'VCh No' => 'V Ch No',
            'GST No' => 'Gst No',
            'product_name' => 'Product Name',
            'Qty' => 'Qty',
            'Rate' => 'Rate',
            'Item Discount' => 'Item Discount',
            'Gross Total' => 'Gross Total',
            'TaxAmount' => 'Tax Amount',
            'VendorDEALER' => 'Vendor/Dealer',
            'Units' => 'Units',
            'Description' => 'Description',
            'Category' => 'Category',
            'Executive'=>'Executive',
            'customer_type'=>'customer_type',
            'discount_type'=>'discount_type',
            'created_by'=>'created_by',
            'gross_amount'=>'Gross amount'



        ];
    }
}
