<?php

namespace backend\modules\reports\models;

use Yii;

/**
 * This is the model class for table "stock_aging_report".
 *
 * @property string|null $date
 * @property string|null $product_id
 * @property string|null $sale_order_no
 * @property string|null $product_name
 * @property float|null $selling_price
 * @property float|null $total
 * @property float|null $fourtyfive_days
 * @property float|null $fourtyfive_ninty_days
 * @property float|null $ninty_days
 */
class StockAgingReport extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public $searchproduct;
    public $type;
    public static function tableName()
    {
        return 'stock_aging_report';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['date'], 'safe'],
            [['selling_price', 'total', 'fourtyfive_days', 'fourtyfive_ninty_days', 'ninty_days'], 'number'],
            [['product_id', 'sale_order_no','searchproduct','type'], 'string', 'max' => 254],
            [['product_name'], 'string', 'max' => 512],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'date' => 'Date',
            'product_id' => 'Product ID',
            'sale_order_no' => 'Sale Order No',
            'product_name' => 'Product Name',
            'selling_price' => 'Selling Price',
            'total' => 'Total',
            'fourtyfive_days' => '45 Days',
            'fourtyfive_ninty_days' => '45 90 Days',
            'ninty_days' => '90 Days',
        ];
    }
}
