<?php

use yii\helpers\Html;
// use yii\grid\GridView;
use yii\helpers\Url;
use yii\widgets\ActiveForm;
use yii\helpers\ArrayHelper;
use backend\modules\master\models\CustomerType;
use common\models\User;
use kartik\grid\GridView;
use backend\modules\master\models\Product;
/* @var $this yii\web\View */
/* @var $searchModel backend\modules\users\models\SaleOrderSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */
$this->title = 'Closing Stock Report';
$this->params['breadcrumbs'][] = $this->title;
?>
<style>


.select2-container .select2-selection--single {
    height: 42px !important;
}
.select2-container--default .select2-selection--single .select2-selection__rendered
{
    line-height: 39px;
}
.select2-container--default .select2-selection--single .select2-selection__arrow
{
    height: 39px;
}
.add_product .select2-selection__rendered {
    width: 220px !important;
}
th a{
    color:#495057;
}
th a:hover{
    color:#495057;
}
body{
    font-family:Arial, Helvetica, sans-serif;
    font-size:13px;
}
.form-control {
    transition: all .2s;
    font-family: Arial, Helvetica, sans-serif;
    font-size: 13px;
}
.pagination li.active a {
    z-index: 1;
    color: #fff;
    background-color: #16aaff;
    border-color: #16aaff;
}
.text-wrap{
white-space: -moz-pre-wrap !important;  /* Mozilla, since 1999 */
white-space: -pre-wrap;      
white-space: -o-pre-wrap;    /* Opera 7 */
white-space: pre-wrap;       /* css-3 */
word-wrap: break-word;       /* Internet Explorer 5.5+ */
white-space: -webkit-pre-wrap; /* Newer versions of Chrome/Safari*/
word-break: break-all;
white-space: normal;
}
</style>
 <?php if (Yii::$app->session->hasFlash('success')) {?>
    <div class="alert alert-success" style="background-color:#dff0d8 !important; text-align:center">
        <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
          <strong style="color:#3c763d"><?=Yii::$app->session->getFlash('success');?></strong>
    </div>
<?php }?>
<?php if (Yii::$app->session->hasFlash('error')): ?>
<div class="alert alert-danger alert-dismissable" style="text-align:center">
     <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
     <?= Yii::$app->session->getFlash('error') ?>
</div>
<?php endif; ?>

<?php 
// $total_opening_balance =0;
$total_inwards =0;
$total_outwards =0;
$total_stock_unit =0;
$total_value =0;
$closing_stock =0;
  if (!empty($dataProvider->getModels())) { 
    foreach ($dataProvider->getModels() as $key => $data) {  
    if($data['value']!='')
    {
       $models = Product::find()->where(['id'=>$data['product_id']])->one();

        $final_price = $models->selling_price * (($data['stock_unit']+$data['inward'])-$data['outward']);
        $amount = number_format((float)($final_price), 2, '.', '');
        // $num = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $amount);

        $total_value = $total_value + $amount;
    }
    $total_inwards = $total_inwards + $data['inward'];
    $total_outwards = $total_outwards + $data['outward'];
    $total_stock_unit = $total_stock_unit + $data['stock_unit'];    
    $closing_stock = $closing_stock + (($data['stock_unit']+$data['inward'])-$data['outward']);
    }

  }
?>

<div class="app-main__inner">
                <div class="card no-shadow bg-transparent no-border rm-borders mb-3">
                            <div class="card">
                                <div class="no-gutters row">
                                    <div class="col-md-12 col-lg-12">
                                        <ul class="list-group list-group-flush">
                                            <li class="bg-transparent list-group-item">
                                                <div class="widget-content p-0">
                                                    <div class="widget-content-outer">
                                                        <div class="widget-content-wrapper">
                                                            <div class="widget-content-left">
                                                                <div class="widget-numbers dj-text-success">Closing Stock Report</div>
                                                            </div>
                                                            
                                                        </div>
                                                    </div>
                                                </div>
                                            </li>
                                          
                                        </ul>
                                    </div>
                                   
                                    
                                </div>
                            </div>
                        </div>
                        <div class="main-card mb-3 card">
                           <div class="card-body">
                           
                           <div class="row dj-adv-search-row">
                           
                            <div class="col-md-1">
                            <a  class="search_field_buttons"  href="<?=Url::base().'/reports/closing-stock/index'?>" role="button" aria-expanded="false" aria-controls="search-look" type="button" title='Refresh Page'><i class="fa fa-refresh" aria-hidden="true"></i></a>
                            </div>
                           </div>
                              
                                </div>
                        </div>
                          <div class="main-card mb-3 card">
                        <div class="card-body">
                     
                        <div class="col-md-12"><h4 style="text-align: center">Stock Summary</h4>
     
      <p style="text-align: center">Basic for valuation: Simple Average Cost Method</p>
      <p style="text-align: center"><strong>As On: <?php echo date('d/m/Y') ?></strong></p>
     
  </div>

           <?= GridView::widget([
            'dataProvider' => $dataProvider,
            'showFooter' => true,
            'summary'=>'',
            'beforeHeader'=>[
            [
              'columns'=>[
                  ['content'=>'Item Details', 'options'=>['colspan'=>1, 'class'=>'text-center warning']], 
                  ['content'=>'Opening Balance', 'options'=>['colspan'=>1, 'class'=>'text-center warning']], 
                  ['content'=>'Inwards', 'options'=>['colspan'=>1, 'class'=>'text-center warning']], 
                  ['content'=>'Outwards', 'options'=>['colspan'=>1, 'class'=>'text-center warning']], 
                  ['content'=>'Closing Balance', 'options'=>['colspan'=>2, 'class'=>'text-center warning']], 
              ],
              'options'=>['class'=>'skip-export'] // remove this row from export
            ]
           ],
           'footerRowOptions'=>['style'=>'font-weight:bold;'],
           "id" => "grid",
          'columns' => [
              [
                  'label' => 'Name',
                  'headerOptions' => ['style' =>'width:20%' ],
                  'contentOptions' => ['class' => 'text-wrap'],
                  'attribute' => 'product_name',
                  'value' => function ($data) { 
                   return $data['product_name'];
              },
               'footer' => 'Grand Total',
              ],
              [
                  'label' => 'Quantity',
                  'headerOptions' => ['style' =>'width:10%' ],
                  'attribute' => 'stock_unit',
                  'value' => function ($data) { 
                   return ($data['stock_unit']);
              },
              'footer' => $total_stock_unit,
              ],
              [
                  'label' => 'Quantity',
                  'headerOptions' => ['style' =>'width:10%' ],
                  'attribute' => 'inward',
                  'value' => function ($data) { 
                   return $data['inward'];
              },
               'footer' => $total_inwards,
              ],
              
              [
                  'label' => 'Quantity',
                  'headerOptions' => ['style' =>'width:10%' ],
                  'attribute' => 'outward',
                  'value' => function ($data) { 
                   return $data['outward'];
              },
                'footer' => $total_outwards,
              ],
              [
                  'label' => 'Quantity',
                  'headerOptions' => ['style' =>'width:10%' ],
                  'attribute' => 'stock_unit',
                  'value' => function ($data) { 
                   return ($data['stock_unit']+$data['inward'])-$data['outward'];
              },
               'footer' => $closing_stock,
              ],

              [
                  'label' => 'Quantity',
                  'headerOptions' => ['style' =>'width:10%' ],
                  'attribute' => 'value',
                  'value' => function ($data) { 
                    $models = Product::find()->where(['id'=>$data['product_id']])->one();

                   $final_price = $models->selling_price * (($data['stock_unit']+$data['inward'])-$data['outward']);
                   $amount = number_format((float)($final_price), 2, '.', '');
                   $num = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $amount);
                   return $num;
              },
                // $amount = number_format((float)($total_value), 2, '.', '');
               'footer' => preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", number_format((float)($total_value), 2, '.', '')),
              ],          
            ],
        ]); ?>

      </div>
  </div>
</div>
<?php ob_start();?>
 <script type="text/javascript">
$(function() {

});
</script>
<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean()))?>

