<?php

use yii\helpers\Html;
// use yii\grid\GridView;
use yii\helpers\Url;
use yii\widgets\ActiveForm;
use yii\helpers\ArrayHelper;
use common\models\User;
use backend\modules\master\models\Vendor;
use kartik\grid\GridView;
/* @var $this yii\web\View */
/* @var $searchModel backend\modules\users\models\SaleOrderSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'GST-3B Report';
$this->params['breadcrumbs'][] = $this->title;
?>
<?php
//print_r($from);die();
?>
<style>
ul.breadcrumb {
padding: 10px 16px;
list-style: none;
}
ul.breadcrumb li a {
color: #0275d8;
text-decoration: none;
}
ul.breadcrumb li+li:before {
  padding: 8px;
  color: black;
  content: "/\00a0";
}
</style>

<div class="row">
<div class="col-md-8">
<h3 class="mt-3 ml-4"><b>GST (OUTWARD SUPPLIES)</b></h3>
</div>
</div>

<div class="path">
<ul class="breadcrumb mx-4">
  <li><a href="#">Home</a></li>
  <li><a href="#">Reports</a></li>
  <li>GST(OUTWARD SUPPLIES)</li>
</ul>
</div>

<div class="row">
<div class="col-md-8">
<h3 class="mt-3 ml-4" style="display:none;"><b>GST (OUTWARD SUPPLIES)</b></h3>
</div>
<div class="col-md-4">
<a href="<?=Url::base().'/reports/gst-report/gstr3?from_date1='.$from_date.'&to_date1='.$to_date?>" class="btn btn-primary mt-3 float-right mr-5"><i class="fa fa-long-arrow-left">&nbsp;Back</i></a>
</div>
</div>

<div class="container my-3">

<?php $form = ActiveForm::begin(['method'=>'get','action' => Url::to(['gst-report/gstr1'])]); ?>
                <div class="row" style="display:none;">
                <label>From period</label>
                <div class="col-md-3">
                <?= $form->field($searchModel, 'from_date')->textInput(['maxlength' => true,'class'=>"form-control date" ,'id'=>'date'])->label(false) ?>
                </div>
                <label>To period</label>
                <div class="col-md-3">
                <?= $form->field($searchModel, 'to_date')->textInput(['maxlength' => true,'class'=>"form-control date" ,'id'=>'date1'])->label(false) ?>
                </div>
                <div class="col-md-3">
                <button class="btn btn-primary " id="search"><i class="fa fa-search">&nbsp;search</i></button>
                </div>      
                </div>
<?php ActiveForm::end(); ?>

    <div class="row mt-3">
        <div class="col-12">
            <div class="card p-4 text-center">
                <div><strong>GSTR-3B Summary</strong></div>
                <div><strong>Mohapatra Scientific Supply</strong></div>
                <div><strong>Period from <?=$from?>
                
                to <?=$to?> </strong></div>
                <table style="width:100%" class="table table-bordered table-striped mt-3">
        <tr>
            <th>Name of Supplies</th>
            <th>Total Taxable value (Rs)</th> 
            <th>Integrated Tax (Rs)</th>
            <th>Central Tax (Rs)</th>
            <th>State/UT Tax (Rs)</th>
            <th>Cess (Rs)</th>
        </tr>
        <tr>
            <td class="text-left">

                <a href="<?=Url::base().'/reports/gstr1-details/gstr3-outward?from_date='.$from."&to_date=".$to ?>">(a)Outward taxable supplies (other than zero rated, nill and exempted)</a>

            </td>
            <td class="text-right"><?=$taxable_amount?></td>
            <td class="text-right"><?=$igst?></td>
            <td class="text-right"><?=$cgst?></td>
            <td class="text-right"><?=$sgst?></td>
            <td class="text-right">0.00</td>
        </tr>
        <tr>
            <td class="text-left"><a href="">(b) Outward taxable supplies (zero rated)</a></td>
            <td class="text-right">0.00</td>
            <td class="text-right">0.00</td>
            <td class="text-right">0.00</td>
            <td class="text-right">0.00</td>
            <td class="text-right">0.00</td>
        </tr>
        <tr>
            <td class="text-left"><a href="">(c) Other outward taxable supplies (nill rated, exempted)</a></td>
            <td class="text-right">0.00</td>
            <td class="text-right">0.00</td>
            <td class="text-right">0.00</td>
            <td class="text-right">0.00</td>
            <td class="text-right">0.00</td>
        </tr>
        <tr>
            <td class="text-left"><a href="">(d) Inward supplies (liable to reverse charge)</a></td>
            <td class="text-right">0.00</td>
            <td class="text-right">0.00</td>
            <td class="text-right">0.00</td>
            <td class="text-right">0.00</td>
            <td class="text-right">0.00</td>
        </tr>
        <tr>
            <td class="text-left"><a href="">(e) Non-GST outward supplies</a></td>
            <td class="text-right">0.00</td>
            <td class="text-right">0.00</td>
            <td class="text-right">0.00</td>
            <td class="text-right">0.00</td>
            <td class="text-right">0.00</td>
        </tr>
        <tr>
            <td class="text-left"><strong>Total tax</strong></td>
            <td class="text-right"><strong><?=$taxable_amount?></strong></td>
            <td class="text-right"><strong><?=$igst?></strong></td>
            <td class="text-right"><strong><?=$cgst?></strong></td>
            <td class="text-right"><strong><?=$sgst?></strong></td>
            <td class="text-right"><strong>0.00</strong></td>
        </tr>
        </table>
            </div>
        </div>    
    </div>
</div>

