<?php

use yii\helpers\Html;
// use yii\grid\GridView;
use yii\helpers\Url;
use yii\widgets\ActiveForm;
use yii\helpers\ArrayHelper;
use common\models\User;
use backend\modules\master\models\Vendor;
use kartik\grid\GridView;
/* @var $this yii\web\View */
/* @var $searchModel backend\modules\users\models\SaleOrderSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'GST Report';
$this->params['breadcrumbs'][] = $this->title;
//print_r($time);die();
?>

<style>
    #search{
        margin-top: 30px;
    }
    ul.breadcrumb {
    padding: 10px 16px;
    list-style: none;
    }
    ul.breadcrumb li a {
    color: #0275d8;
    text-decoration: none;
    }
    ul.breadcrumb li+li:before {
    padding: 8px;
    color: black;
    content: "/\00a0";
    }
    .card{
        min-height:180px;
    }
</style>

<div class="container mt-5">
    <h3><b>GST Reports</b></h3>
    <ul class="breadcrumb ">
    <li><a href="#">Home</a></li>
    <li><a href="#">GST Reports</a></li>
    </ul>
    <div class="row">
    <div class="col-md-12">
            <div class="card p-4">
            <!-- <h5><strong>For Period:</strong></h5> -->
            <?php $form = ActiveForm::begin(['method'=>'get','action' => Url::to(['gst-report/index'])]); ?>
            <div class="row">
            <!-- <label>For period</label> -->
            <div class="col-md-3">
                <?php 
                //print_r($searchModel->to_date);die();
                if($searchModel->to_date){?>
                 <?=$form->field($searchModel, 'to_date')->textInput(['maxlength' => true,'class'=>"form-control" ,'id'=>'date'])->label('For Period');?>
                 <?php
                }
                else if($from_date){?>
                <?=$form->field($searchModel, 'to_date')->textInput(['maxlength' => true,'class'=>"form-control" ,'id'=>'date','value'=>date('Y-m', strtotime($from_date))])->label('For Period');?>
                <?php }   
                else{?>
                    <?=$form->field($searchModel, 'to_date')->textInput(['maxlength' => true,'class'=>"form-control" ,'id'=>'date', 'value'=>date('Y-m', strtotime($to))])->label('For Period');?>
                    <?php
                }?>

            </div> 
            <div class="col-md-3">
                <button class="btn btn-primary" id="search"><i class="fa fa-search">&nbsp;search</i></button>
            </div>
            </div>
            <?php ActiveForm::end(); ?>
            </div>
        </div>   
    </div>
    <div class="row mt-3">
        <div class="col-12 col-md-6">
            <div class="card">
                <div class="card-header">



                 <?php if($searchModel->to_date ==''){?>

                <a href="<?=Url::base().'/reports/gstr1-details/index'?>">gstr-1 report</a>       
                <?php }else {?>

                     <a href="<?=Url::base().'/reports/gstr1-details/index?datefrom='.$searchModel->to_date ?>">gstr-1 report</a>
                <?php } ?>    

                    
                </div>
                <div class="card-body pb-0">Details of outward supplies of goods or services.</div>
                <div class="card-body"><b>Taxable Value:&nbsp;</b><?=$total_amt_outward?>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<b>Tax Amount:&nbsp;</b><?=$total_tax_outward?></div>
                <div class="card-footer"></div>
            </div>
        </div>
        <div class="col-12 col-md-6">
            <div class="card">
                <div class="card-header"><a href="<?=Url::base().'/reports/gst-report2/index'?>">gstr-2a report</a></div>
                <div class="card-body">Reconcile your GSTR-2A, Generate Report here.</div>
                <div class="card-footer"></div>
            </div>
        </div>
    </div>
    <div class="row mt-3 mb-3">
    <div class="col-12 col-md-6">
        <div class="card">
            <div class="card-header"><a href="<?=Url::base().'/reports/gst-report/gstr3?from_date1='.$from_date.'&to_date1='.$to_date?>">gstr-3b report</a></div>
            <div class="card-body pb-0">Monthly Returns</div>
            <div class="card-body"><strong>Net GST Payable:&nbsp;<?=($total_tax_outward-$total_tax_inward)?></strong>
            </div>

            <div class="card-footer"></div>
        </div>
    </div>
    </div>
</div>
<?php ob_start();?>
<script language="JavaScript" type="text/javascript">
  $('#date').attr('type','month');
  $('#date1').attr('type','month');
</script>
<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean()))?>
