<?php

use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;
use common\models\User;
use backend\modules\master\models\Product;
use backend\modules\master\models\CallStatus;
use backend\modules\master\models\BusinessType;
use backend\modules\master\models\LeadExecutive;
use yii\widgets\ActiveForm;
use yii\helpers\ArrayHelper;
use backend\models\AuthAssignment;
use backend\models\AuthItemChild;
use backend\modules\master\models\AccountingLedger;
use backend\modules\master\models\GroupName;
use backend\modules\master\models\AccountType;

$id = Yii::$app->user->identity->id;
$assign = AuthAssignment::find()->where(['user_id' => $id])->one();

/* @var $this yii\web\View */
/* @var $searchModel backend\modules\master\models\LeadsSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Negative Stock Report';
$this->params['breadcrumbs'][] = $this->title;
?>
<style>
    .text-wrap {
        white-space: -moz-pre-wrap !important;
        /* Mozilla, since 1999 */
        white-space: -pre-wrap;
        /* Opera 4-6 */
        white-space: -o-pre-wrap;
        /* Opera 7 */
        white-space: pre-wrap;
        /* css-3 */
        word-wrap: break-word;
        /* Internet Explorer 5.5+ */
        white-space: -webkit-pre-wrap;
        /* Newer versions of Chrome/Safari*/
        word-break: break-all;
        white-space: normal;
    }

    .select2-container .select2-selection--single {
        height: 42px !important;
    }

    .select2-container--default .select2-selection--single .select2-selection__rendered {
        line-height: 39px;
    }

    .select2-container--default .select2-selection--single .select2-selection__arrow {
        height: 39px;
    }

    th a {
        color: #495057;
    }

    th a:hover {
        color: #495057;
    }

    body {
        font-family: Arial, Helvetica, sans-serif;
        font-size: 13px;
    }

    .form-control {
        transition: all .2s;
        font-family: Arial, Helvetica, sans-serif;
        font-size: 13px;
    }

    .pagination li.active a {
        z-index: 1;
        color: #fff;
        background-color: #16aaff;
        border-color: #16aaff;
    }

    @media print {

        .dj-adv-search-row,
        .summary,
        .pagination {
            display: none !important;
        }

        .dj-print-sec {
            display: none !important;
        }

        .widget-content-wrapper {
            display: none !important;
        }

        .table-responsive {
            overflow: hidden;
        }

        .app-header__menu {
            display: none !important;
        }

        .print_header {
            display: block;
            color: black;
            font-size: 15px;
        }

        .table {
            border: 2px solid #000;
        }

        .table td {
            border: 2px solid #000 !important;
        }

        .table th {
            border: 2px solid #000 !important;
        }

    }
</style>
<div class="app-main__inner">
    <div class="card no-shadow bg-transparent no-border rm-borders mb-3">
        <div class="card">
            <div class="no-gutters row">
                <div class="col-md-12 col-lg-12">
                    <ul class="list-group list-group-flush">
                        <li class="bg-transparent list-group-item">
                            <div class="widget-content p-0">
                                <div class="widget-content-outer">
                                    <div class="widget-content-wrapper">
                                        <div class="widget-content-left">
                                            <div class="widget-numbers dj-text-success">Negative Stock Report</div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </li>

                    </ul>
                </div>

            </div>
        </div>
    </div>



    <div class="main-card mb-3 card">
        <div class="card-body">

            <div class="col-md-12">
                <h4 style="text-align: center">Stock Summary</h4>

                <p style="text-align: center">Basic for valuation: Simple Average Cost Method</p>
                <p style="text-align: center"><strong>As On: <?php echo date('d/m/Y') ?></strong></p>

            </div>

            <?= GridView::widget([
                'dataProvider' => $dataProvider,
                // 'filterModel' => $searchModel,
                'columns' => [
                    [
                        'headerOptions' => ['style' => 'color:#495057', 'width:1000px'],
                        'header' => 'Name',
                        'attribute' => 'product_name',
                        'format' => 'raw',
                        'value' => function ($data) {
                            $product = Product::find()->where(['product_name'=>$data->product_name])->one();
                            $pro_details = '<a class="nav-link" href='.Url::base().'/reports/nagative-stock/negative-stock-details?prod_id='."$product->id".' data-method=post>'.$data->product_name.' </a>';
                            return $pro_details;
                        }
                    ],
                    [
                        'headerOptions' => ['style' => 'color:#495057', 'width:1000px'],
                        'header' => 'Opening Stock',
                        'attribute' => 'opening_stock',
                        'value' => function ($data) {
                            return $data->opening_stock;
                        }
                    ],
                    [
                        'headerOptions' => ['style' => 'color:#495057', 'width:1000px'],
                        'header' => 'Selling Price (Rs.)',
			'contentOptions'=>[ 'style'=>'text-align:right'],
                        'attribute' => 'selling_price',
                        'value' => function ($data) {
			   return preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", (number_format((float)($data->selling_price), 2, '.', '')));
                           //return $data->selling_price;
                        }
                    ],
                    [
                        'headerOptions' => ['style' => 'color:#495057', 'width:1000px'],
                        'header' => 'Vendor',
                        'attribute' => 'vendor',
                        'value' => function ($data) {
                            return $data->vendor;
                        }
                    ],
                    [
                        'headerOptions' => ['style' => 'color:#495057', 'width:1000px'],
                        'header' => 'Inwards Quantity',
                        'attribute' => 'inward_amount',
                        'value' => function ($data) {
                            return $data->inward_amount;
                        }
                    ],
                    [
                        'headerOptions' => ['style' => 'color:#495057', 'width:70px'],
                        'header' => 'Outwards Quantity',
                        'attribute' => 'outward_amount',
                        'value' => function ($data) {
                            return $data->outward_amount;
                        }
                    ],
                    [
                        'headerOptions' => ['style' => 'color:#495057', 'width:70px'],
                        'header' => 'Closing Balance',
                        'attribute' => 'outstanding_amount',
                        'value' => function ($data) {
                            return $data->outstanding_amount;
                        }
                    ],

                ],
            ]); ?>
        </div>
    </div>
</div>
<?php ob_start(); ?>
<script type="text/javascript">
    $(function() {

    });
</script>
<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean())) ?>
