<?php

use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;
use common\models\User;
use yii\helpers\ArrayHelper;
use backend\modules\master\models\Customer;

/* @var $this yii\web\View */
/* @var $searchModel backend\models\TicketsSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Purchase Report';
$this->params['breadcrumbs'][] = $this->title;
?>
<style>
    table, th, td {
        border: 1px solid black !important;
        border-collapse: collapse !important;

    }
    th, td {
        padding: 5px !important;
        text-align: left !important;
        color:black !important;

    }
    th{
        border:none;
        background-color:slategray;
    }
</style>
<?php
$inv_amt=0;$unpaid_amt=0;$paid_amt=0;
if (!empty($dataProvider->getModels())) {
    foreach ($dataProvider->getModels() as $key => $val) {
      $inv_amt+=$val->amount;
        $unpaid_amt+=$val->pending;
        $paid_amt+=$val->paid;
        // $total_bill+=$val->bill_total;
        // $total_paid+=$val->paid_amount;
        // $total_other+=$val->other_charges;
    }

}
?>
<p style="text-align: center"><strong>MOHAPATRA SCIENTIFIC PRIVATE LIMITED</strong>
    <br>
    <br>F2G/30, INDRADHANU MARKETIRC VILLAGE, <br>BHUBANESWAR
<h2 style="text-align:center">Statement Of Account</h2>

    <h4 style="text-align: right"><?= date("d/m/Y")?></h4>
</p>
<?= GridView::widget([
    'dataProvider' => $dataProvider,
    'summary'=> '',
    'showFooter' => true,
    'footerRowOptions'=>['style'=>'font-weight:bold;'],
    'columns' => [

        [
            'label'=>'Customer',
            'visible' => $is_customer,
            'value'=>function($data){
                return Customer::find()->where(['id'=>$data->customer_id])->one()->business_name;
            }
        ],
        [
            'label'=>'Invoice No.',
            'visible' => $is_invoiceid,
            'value'=>function($data){
                return $data->invoice_id;
            }
        ],
        [
            'label'=>'Mobile',
            'visible' => $is_mobile,
            'value'=>function($data){
                return Customer::find()->where(['id'=>$data->customer_id])->one()->mobile;
            }
        ],
        [
            'label'=>'Phone',
            'visible' => $is_phone,
            'value'=>function($data){
                return Customer::find()->where(['id'=>$data->customer_id])->one()->phone;
            }
        ],
        [
            'label'=>'Date',
            'visible' => $is_date,
            'value'=>function($data){
                return $data->date;
            }
        ],
        [
            'label'=>'Amount',
            'visible' => $is_amt,
            'value'=>function($data){
                return $data->amount;
            },
            'footer'=> Yii::$app->formatter->asCurrency(round($inv_amt,2),'INR')

        ],
        [
            'label'=>'Paid Amt',
            'visible' => $is_paidamt,
            'value'=>function($data){
                return $data->paid;
            },
            'footer'=> Yii::$app->formatter->asCurrency(round($paid_amt,2),'INR')

        ],
        [
            'label'=>'Unpaid Amt',
            'visible' => $is_unpaidamt,
            'value'=>function($data){
                return $data->pending;
            },
            'footer'=> Yii::$app->formatter->asCurrency(round($unpaid_amt,2),'INR')

        ],
        [
            'label'=>'Due Date',
            'visible' => $is_duedate,
            'value'=>function($data){
                return $data->due_date;
            }
        ],
        [
            'label'=>'Days Crossed',
            'visible' => $is_days,
            'value'=>function($data){
                return $data->due_days_crossed;
            }
        ],
        [
            'label'=>'Executive',
            'visible' => $is_executives,
            'value'=>function($data){
                return $data->executive;
            }
        ],
        [
            'label'=>'Notes',
            'visible' => $is_notes,
            'value'=>function($data){
                return $data->is_notes;
            }
        ],
        [
            'label'=>'Terms',
            'visible' => $is_terms,
            'value'=>function($data){
                return 'Terms';
            }
        ],
        [
            'label'=>'Current Outstanding',
            'visible' => $is_currentoutstanding,
            'value'=>function($data){
                return '0.00';
            },
            'footer'=> Yii::$app->formatter->asCurrency(round(0,2),'INR')

        ],
        [
            'label'=>'Overdue',
            'visible' => $is_overdue,
            'value'=>function($data){
                return $data->pending;
            },
            'footer'=> Yii::$app->formatter->asCurrency(round($unpaid_amt,2),'INR')

        ],
        [
            'label'=>'Total Invoice',
            'visible' => $is_totaloutstanding,
            'value'=>function($data){
                return $data->pending;
            },
            'footer'=> Yii::$app->formatter->asCurrency(round($unpaid_amt,2),'INR')

        ],

    ],

]); ?>


</div>
</div>
</div>
