<?php

use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;
use yii\widgets\ActiveForm;
use backend\modules\master\models\Customer;
use backend\modules\master\models\LeadExecutive;
use yii\helpers\ArrayHelper;
use backend\modules\master\models\CustomerType;
use backend\modules\users\models\SaleOrder;
use common\models\User;
/* @var $this yii\web\View */
/* @var $searchModel backend\modules\users\models\SaleOrderSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Overdue Invoice';
$this->params['breadcrumbs'][] = $this->title;
?>
<style>
th a{
    color:#495057;
}
th a:hover{
    color:#495057;
}
body{
    font-family:Arial, Helvetica, sans-serif;
    font-size:13px;
}
.form-control {
    transition: all .2s;
    font-family: Arial, Helvetica, sans-serif;
    font-size: 13px;
}
.pagination li.active a {
    z-index: 1;
    color: #fff;
    background-color: #16aaff;
    border-color: #16aaff;
}
</style> <?php if (Yii::$app->session->hasFlash('success')) {?>
    <div class="alert alert-success" style="background-color:#dff0d8 !important; text-align:center">
        <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
          <strong style="color:#3c763d"><?=Yii::$app->session->getFlash('success');?></strong>
    </div>
<?php }?>
<?php if (Yii::$app->session->hasFlash('error')): ?>
<div class="alert alert-danger alert-dismissable" style="text-align:center">
     <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
     <?= Yii::$app->session->getFlash('error') ?>
</div>
<?php endif; ?>
<?php
 $users=ArrayHelper::map(User::find()->all(),'id','username');
 $executive_items=ArrayHelper::map(LeadExecutive::find()->all(),'name','name');
 $customertype_items=ArrayHelper::map(CustomerType::find()->all(),'customer_type','customer_type');


?>
<div class="app-main__inner">
    <div class="card no-shadow bg-transparent no-border rm-borders mb-3">
        <div class="card">
            <div class="no-gutters row">
                <div class="col-md-12 col-lg-12">
                    <ul class="list-group list-group-flush">
                        <li class="bg-transparent list-group-item">
                            <div class="widget-content p-0">
                                <div class="widget-content-outer">
                                    <div class="widget-content-wrapper">
                                        <div class="widget-content-left">
                                            <div class="widget-numbers dj-text-success">Sales Overdue Invoice</div>
                                        </div>
                                        <div class="widget-content-right">
                                            <div class="djsec-text-right dj-print-sec">

                                                <?php if(Yii::$app->request->getQueryParams()){?>
                                                    <a href='' data-toggle="modal" data-target="#pe" >  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-print" aria-hidden="true"></i>  Print &nbsp;/&nbsp;<i class="fa fa-file-excel-o" aria-hidden="true"></i>Excel</button></a>
                                                <?php } else{ ?>
                                                    <a href='' data-toggle="modal" data-target="#pe" >  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-print" aria-hidden="true"></i>  Print &nbsp;/&nbsp;<i class="fa fa-file-excel-o" aria-hidden="true"></i>Excel</button></a>
                                                <?php } ?>
                                                <?php if(Yii::$app->request->getQueryParams()){?>
                                                    <a href="<?=Url::current()?>&excel=true" data-method="post"> <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-print"></i>Aging Print</button></a>
                                                <?php } else{ ?>
                                                    <a href="<?=Url::current()?>?excel=true" data-method="post"> <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-print"></i>Aging Print</button></a>
                                                <?php } ?>
                                               
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </li>

                    </ul>
                </div>
            </div>
        </div>
    </div>
    <div class="main-card mb-3 card">
        <div class="card-body">
            <div class="row dj-adv-search-row">
                <div class="col-md-11">
                    <a id="advance-search" class="search_field_buttons" data-toggle="collapse" href="#search-look" role="button" aria-expanded="false" aria-controls="search-look" type="button">Advance Search <i class="fa fa-chevron-down" aria-hidden="true"></i></a>
                </div>
                <div class="col-md-1">
                    <a  class="search_field_buttons"  href="<?=Url::base().'/reports/overdue-invoice-report/index'?>" role="button" aria-expanded="false" aria-controls="search-look" type="button" title='Refresh Page'><i class="fa fa-refresh" aria-hidden="true"></i></a>
                </div>
            </div>
            <div class="dj-sale-form collapse" id="search-report">
                <?php $form = ActiveForm::begin(['method' => 'get']); ?>
                <form>
                    <div class="form-row">
                        <div class="col-md-4">
                            <div class="position-relative form-group">
                                <label for="notes">From</label>
                                <?= $form->field($model, 'from_date')->textInput(['type'=>'date','maxlength' => true,'class'=>"form-control "])->label(false) ?>
                                <!-- <select class=" multiselect-dropdown form-control">
                                    <option>Sale Type</option>
                                </select>  -->
                            </div>
                        </div>
                        <div class="col-md-4">
                            <div class="position-relative form-group">
                                <label for="notes">To</label>
                                <?= $form->field($model, 'to_date')->textInput(['type'=>'date','maxlength' => true,'class'=>"form-control "])->label(false) ?>
                                <!-- <select class=" multiselect-dropdown form-control">
                                    <option>Sale Type</option>
                                </select>  -->
                            </div>
                        </div>
                        <div class="col-md-4">
                            <div class="position-relative form-group">
                                <label for="notes">Customer</label>
                                <?php if($model->c_name != ''){?>
                                    <?php $customer =Customer::find()->where(['business_name'=>$model->c_name])->one(); ?>
                                    <?= $form->field($model, 'c_name')->dropDownList([$model->c_name=>$customer->business_name],['prompt'=>'--Select--' , 'class'=>'findcustomer select form-control'])->label(false) ?>
                                <?php }else {?>
                                    <?= $form->field($model, 'c_name')->dropDownList([],['prompt'=>'--Select--' , 'class'=>'findcustomer select form-control'])->label(false) ?>
                                <?php } ?>                           
                            </div>
                        </div>
                        <div class="col-md-4">
                            <div class="position-relative form-group">
                                <label for="notes">Select a User</label>
                                <?= $form->field($model, 'creator')->dropDownList($users,['prompt'=>'-Select User-','class'=>'selectclass select form-control'])->label(false) ?>
                            </div>
                        </div>
                        <div class="col-md-4">
                            <div class="position-relative form-group">
                                <label for="notes">Executive</label>
                                <?= $form->field($model, 'exe')->dropDownList($executive_items,['prompt'=>'-Select Executive-','class'=>'selectclass select form-control'])->label(false) ?>
                            </div>
                        </div>
                        <div class="col-md-4">
                            <div class="position-relative form-group">
                                <label for="notes">Customer Type</label>
                                <?= $form->field($model, 'c_type')->dropDownList($customertype_items,['prompt'=>'-Select Category-','class'=>'selectclass select form-control'])->label(false) ?>
                            </div>
                        </div>
                        <div class="col-md-4">
                            <div class="position-relative form-group">
                                <label for="notes">Order By</label>
                                <?= $form->field($model, 'order')->dropDownList(['casc'=>'Customer Name ASC','cdsc'=>'Customer Name DESC','ddasc'=>'Due Days ASC','dddsc'=>'Due Days DESC'],['prompt'=>'--Order By--','class'=>'form-control select selectclass'])->label(false) ?>
                            </div>
                        </div>

                    </div>
                    <div class="col-md-12 dj-btn-align djsec-text-right">
                        <?= Html::submitButton('<span class="fa fa-search"></span> Search', ['class' => 'btn btn-info btn-rounded dj-search','style'=>"padding: 9px 21px"]) ?>
                    </div>

                </form>
                <?php ActiveForm::end(); ?>
            </div>
        </div>
    </div>
    <div class="main-card mb-3 card">
        <div class="card-body">

            <?= GridView::widget([
                'dataProvider' => $dataProvider,
                'showFooter' => true,
                'footerRowOptions'=>['style'=>'font-weight:bold;'],
                "id" => "grid",
                'columns' => [
                     [
                             'label'=>'Customer/Category/Mobile',
                              'value'=>function($data){
                                return  $data->customer_name;
                              }
                     ],
                    [
                        'label'=>'Invoice #',
                        'value'=>function($data){
                            return $data->invoice_id;
                        }
                    ],
                    [
                        'label'=>'Date',
                        'value'=>function($data){
                            return $data->date;
                        }
                    ],
                    [
                        'label'=>'Amount',
                        'value'=>function($data){
                            return $data->amount;
                        }
                    ],
                    [
                        'label'=>'Paid',
                        'value'=>function($data){
                            return $data->paid;
                        }
                    ],
                    [
                        'label'=>'Pending',
                        'value'=>function($data){
                            return $data->pending;
                        }
                    ],
                    [
                        'label'=>'Due Days Crossed',
                        'value'=>function($data){
                            return $data->due_days_crossed;
                        }
                    ],
                    [
                        'label'=>'Executive',
                        'value'=>function($data){
                            return $data->executive;
                        }
                    ],
                    [
                        'label'=>'Status',
                        'format'=>'raw',
                        'value'=>function($data){
                                           if($data['status'])
                                                {
                                                    // return $data['status'];
                                                    // if($data['status']=='Paid')
                                                    if(($data['status'])=='Paid')
                                                    {
                                                         return '<span class="label-paid">PAID</span>';
                                                    }
                                                    // else if($data['status']=='Pending')
                                                    else if(($data['status'])=='Pending')

                                                    {
                                                     return '<span class="label-draft">PENDING</span>';
                                                    }
                                                    // else if ($data['status']=='Partially Paid')
                                                    else if(($data['status'])=='Partially Paid')
                                                    {
                                                     return '<span class="label-partial">PARTIAL</span>';
                                                    }
                                                    else{
                                                        return $data->status;
                                                    }
                                                }                        }
                    ],
                    [
                        'label' => 'Action',
                        // 'attribute' => 'username',
                        'headerOptions' => ['style' => 'color:#495057'],
                        'format'=>'raw',
                        'contentOptions'=>[ 'style'=>'width: 35px'],
                        'value' => function ($data) {
                            return '<div class="d-inline-block dropdown">
                    <button type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" class="btn-shadow dropdown-toggle btn btn-info dj-action-btn">Action</button>
                    <div tabindex="-1" role="menu" aria-hidden="true" class="dropdown-menu dropdown-menu-right dj-action-drop">
                        <ul class="nav flex-column">
                        <li class="nav-item">
                                <a class="nav-link" href='.Url::base().'/users/invoice/invoice-pdf?id='.$data->id.' data-method=post>
                                    <i class="fa fa-file-pdf-o"></i>
                                    <span class="dj-icon-gap">PDF Invoice</span>
                                </a>
                            </li>
                            <li class="nav-item">
                            <a class="nav-link" href='.Url::base().'/users/invoice/printall?id='.$data->id.' data-method=post target=_blank>
                                <i class="fa fa-print"></i>
                                <span class="dj-icon-gap"> Print Invoice</span>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link" href='.Url::base().'/users/invoice/view?id='.$data->id.' data-method=post>
                                <i class="fa fa-eye"></i>
                                    <span class="dj-icon-gap">  View</span>
                                </a>
                            </li>
                            <li class="nav-item">
                                <a class="nav-link" href='.Url::base().'/users/invoice/update?id='.$data->id.' data-method=post>
                                    <i class="fa fa-pencil-square"></i>
                                    <span class="dj-icon-gap">Edit</span>
                                </a>
                            </li>                            
                            <li class="nav-item">
                                <a class="nav-link" href=>
                                    <i class="fa fa-envelope-o"></i>
                                    <span class="dj-icon-gap">Mail Invoice</span>
                                </a>
                            </li>

                            <li class="nav-item">
                            <a class="nav-link" href='.Url::base().'/users/receipt-details/create?id='.$data->id.'&from=invoice>
                            <i class="fa fa-plus"></i>
                                    <span class="dj-icon-gap"> Add Receipt</span>
                                </a>
                            </li>
                            <li class="nav-item">
                                <a class="nav-link" href="">
                                    <i class="fa fa-whatsapp"></i>
                                    <span class="dj-icon-gap"> Whatsapp Invoice</span>
                                </a>
                            </li>
                           </ul>
                    </div>
                </div>';
                        },
                    ],

                ],
            ]); ?>
            
        </div>
    </div>
</div>
<div class="modal fade" id="pe">
    <div class="modal-dialog modal-md">
        <?php $form = ActiveForm::begin(); ?>
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="exampleModalLongTitle">Choose the fields </h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
              
              <form class="dj-sale-form">
                <div class="form-row">
                 <div class="col-md-12">
                      <div class="position-relative form-group">
                      <?= $form->field($model, 'is_customer')->checkBox(['label' =>'','class'=>'customer'])->label('Customer') ?>   
                      <?= $form->field($model, 'is_invoiceid')->checkBox(['label' =>'','class'=>'customer'])->label('Invoice No') ?>  
                      <?= $form->field($model, 'is_mobile')->checkBox(['label' =>'','class'=>'customer'])->label('Customer Mobile') ?>   
                      <?= $form->field($model, 'is_phone')->checkBox(['label' =>'','class'=>'customer'])->label('Customer Phone') ?>   
                      <?= $form->field($model, 'is_date')->checkBox(['label' =>'','class'=>'customer'])->label('Date') ?>   
                      <?= $form->field($model, 'is_amt')->checkBox(['label' =>'','class'=>'customer'])->label('Invoice Amt') ?>   
                      <?= $form->field($model, 'is_paidamt')->checkBox(['label' =>'','class'=>'customer'])->label('Paid Amt') ?>   
                      <?= $form->field($model, 'is_unpaidamt')->checkBox(['label' =>'','class'=>'customer'])->label('Unpaid Amt') ?>   
                      <?= $form->field($model, 'is_duedate')->checkBox(['label' =>'','class'=>'customer'])->label('Due Date') ?>   
                      <?= $form->field($model, 'is_days')->checkBox(['label' =>'','class'=>'customer'])->label('Days') ?>   
                      <?= $form->field($model, 'is_executives')->checkBox(['label' =>'','class'=>'customer'])->label('Executive') ?>   
                      <?= $form->field($model, 'is_notes')->checkBox(['label' =>'','class'=>'customer'])->label('Notes') ?>   
                      <?= $form->field($model, 'is_terms')->checkBox(['label' =>'','class'=>'customer'])->label('Terms') ?>   
                      <?= $form->field($model, 'is_currentoutstanding')->checkBox(['label' =>'','class'=>'customer'])->label('Current Outstanding') ?>   
                      <?= $form->field($model, 'is_overdue')->checkBox(['label' =>'','class'=>'customer'])->label('Over Due') ?>   
                      <?= $form->field($model, 'is_totaloutstanding')->checkBox(['label' =>'','class'=>'customer'])->label('Total Outstanding') ?>   
                    </div>
                          
                    </div> 
                    
                </div>
              </form>
            </div>
            <div class="modal-footer">
              <div class="col-md-12">                                       
                <div class="djsec-text-right">
                    <?= Html::submitButton('<i class="fa fa-print" aria-hidden="true"></i> Print', ['class' => 'btn dj-blue-btn submit-btn' , 'value'=>'export_print', 'name'=>'print']) ?>
                    <?= Html::submitButton('<i class="fa fa-file-excel-o" aria-hidden="true"></i> Excel', ['class' => 'btn dj-blue-btn submit-btn', 'value'=>'export_excel', 'name'=>'excel']) ?>
                    <a href="" class="btn dj-red-btn" data-dismiss="modal" aria-label="Close" onclick="window.location.href=window.location.href"><i class="fa fa-ban" aria-hidden="true"></i> Close</a>
                  </div>
                </div>
            </div>
        </div>
        <?php ActiveForm::end(); ?>  
    </div>
</div>
    <?php ob_start();?>
<script type="text/javascript">
    $(function() {

$('#advance-search').click(function(){
            $('#search-report').toggle();
        });

        $('.selectclass').select2();
 
        $('.findcustomer').select2({
            ajax: {
                url: "customerdetails",
                type: "get",
                dataType: 'json',
                delay: 250,
                data: function (params) {
                    return {
                        searchTerm: params.term // search term
                    };
                },
                processResults: function (response) {

                    return {
                        results: $.map(response, function (i,item) {

                            return {
                                text: i,
                                slug: "",
                                id: item
                            }
                        })
                    };
                },
                cache: true
            }
        });
        
    });

</script>
<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean()))?>
