<?php

use yii\helpers\Html;
use yii\widgets\DetailView;
use backend\modules\master\models\LeadExecutive;
use yii\helpers\url;
use yii\grid\GridView;

use backend\modules\master\models\Product;
use backend\modules\master\models\Vendor;
use backend\modules\master\models\Customer;
use backend\modules\users\models\SaleOrderProduct;
use backend\modules\users\models\SaleOrder;
use backend\modules\reports\models\SaleOrderReport;

/* @var $this yii\web\View */
/* @var $model backend\modules\users\models\LeadsQuotes */


\yii\web\YiiAsset::register($this);
?>
<style>
    body
  {
    font-size: 15px;
  }
table, th, td {
  border: 1px solid #CDCBCB;
  border-collapse: collapse !important;

}
th, td {
  padding: 5px !important;
  text-align: left !important; 

}
th
{
  background-color: #CDCBCB;
  border: none;
}
td
{
  border: 1px solid #CDCBCB;
}
</style>
<div class="app-main__inner">

     <h1 style="text-align:center; font-size: 15px">Sales Order Detail Report</h1>

     <p style="text-align:center">
      <?php
         if($model->from_date!='' && $model->to_date!='')
         {
           echo  date('d/m/Y', strtotime($model->from_date))." to ".date('d/m/Y', strtotime($model->to_date));
         }
         else
         {

         }
      ?>
    </p>


     <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'columns' => [
            
            [
                'label'=>'Date',
                'format' => ['date', 'php:d/m/Y'],
                'value'=>function($data)
                {
                    $particulars = SaleOrderReport::find()->where(['sale_order_id'=>$data->sale_order_id])->one();
                    if($particulars!='')
                    return $particulars->Date;
                }
            ],
             [
                'label'=>'SO No.',
                'value'=>function($data)
                {
                    $particulars = SaleOrder::find()->where(['id'=>$data->sale_order_id])->one();
                    if($particulars!='')
                    return $particulars->sale_order_id;
                }
            ],
            [
                'label'=>'Customer',
                'value'=>function($data)
                {
                    $particulars = SaleOrderReport::find()->where(['sale_order_id'=>$data->sale_order_id])->one();
                    if($particulars!='')
                    return $particulars->Particulars;
                }
            ],
            [
                'label'=>'Product Name',
                'value'=>function($data)
                {
                   return  Product::find()->where(['id'=>$data->product_id])->one()->product_name;
                }
            ],
            [
                'label'=>'Qty',
                'value'=>function($data)
                {
                   return  $data->Qty;
                }
            ],
            [
                'label'=>'Tax',
                'value'=>function($data)
                {
                   if($data->tax_included==1)
                    {
                        if($data->discount_type=="FLAT")
                        {
                            return  $data->gross_amount-($data->GrossTotal-$data->ItemDiscount);
                        }
                        else if($data->discount_type=="%")
                        {
                            return $data->gross_amount-($data->GrossTotal-(($data->GrossTotal*$data->ItemDiscount)/100));
                        }
                        else
                        {
                            return  $data->gross_amount - $data->GrossTotal;
                        }

                    }
                    else
                    {
                         return  '0';
                    }
                }
            ],
            [
                'label'=>'Price',
                'value'=>function($data)
                {
                    if($data->discount_type=="FLAT")
                       return  $data->GrossTotal-$data->ItemDiscount;
                    if($data->discount_type=="%")
                       return  $data->GrossTotal-(($data->GrossTotal*$data->ItemDiscount)/100);
                   if($data->discount_type=="")
                       return  $data->GrossTotal;
                }
            ],
            [
               'label'=>'Tcs',
               'format'=>['decimal',2],
               'value'=>function($data)
                {
                   
                     $models = SaleOrder::find()->where(['id'=>$data->sale_order_id])->one();
                     if($models->is_tcs==1)
                      {
                        $tcs_percentage = (($models->tcs_amount/($models->total_amount-$models->tcs_amount)*100));
                        $product_tcs = ($data->gross_amount*($tcs_percentage/100));
                        return $product_tcs;                      }
                      else
                      {
                        return 0;
                      }

                }

            ],
            [
                'label'=>'Total',
                 'format'=>['decimal',2],
                'value'=>function($data)
                {

                   $models = SaleOrder::find()->where(['id'=>$data->sale_order_id])->one();
                   if($models->is_tcs==1)
                    {
                      $tcs_percentage = (($models->tcs_amount/($models->total_amount-$models->tcs_amount)*100));
                      $product_tcs = ($data->gross_amount*($tcs_percentage/100));

                     return $product_tcs+$data->gross_amount;
                    }
                    else
                    {
                      return $data->gross_amount;
                    }
                }
            ],
            [
                'label'=>'Delivered',
                'value'=>function($data)
                {
                   $particulars = SaleOrder::find()->where(['id'=>$data->sale_order_id])->one();
                    if($particulars->dc_status>=1)
                    {
                        return  $data->Qty;
                    }
                    else
                    {
                        return 0;
                    }
                }
            ],
            [
                'label'=>'Pending',
                'value'=>function($data)
                {
                   $particulars = SaleOrder::find()->where(['id'=>$data->sale_order_id])->one();
                    if($particulars->dc_status<1)
                    {
                        return  $data->Qty;
                    }
                    else
                    {
                        return 0;
                    }
                }
            ],
            [
                'label'=>'Status',
                'value'=>function($data)
                {
                    $particulars = SaleOrder::find()->where(['id'=>$data->sale_order_id])->one();
                    if($particulars->dc_status==2)
                    {
                        return  'DELIVERED';
                    }
                    else
                    {
                        return 'PENDING';
                    }
                }
            ],

        ],
    ]) ?>
</div>
